import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkOrderLog, ThinkOrderLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkOrderLog(params: ThinkOrderLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkOrderLog>>>(
    THINK_API_URL + '/think/think-order-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkOrderLog(params?: ThinkOrderLogParam) {
  const res = await request.get<ApiResult<ThinkOrderLog[]>>(
    THINK_API_URL + '/think/think-order-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkOrderLog(data: ThinkOrderLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkOrderLog(data: ThinkOrderLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkOrderLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkOrderLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkOrderLog(id: number) {
  const res = await request.get<ApiResult<ThinkOrderLog>>(
    THINK_API_URL + '/think/think-order-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
